#include <avr/io.h>
#include <util/delay.h>


#define rs(a)  (PORTC = (PORTC & ~_BV(PC0)) | ((a) << PC0))
#define rw(b)  (PORTC = (PORTC & ~_BV(PC1)) | ((b) << PC1))
#define en(c)  (PORTC = (PORTC & ~_BV(PC2)) | ((c) << PC2))

#define sbit RS = PORTB.0;
#define lcd_data_pin PORTD
//Functions
void test(unsigned char data1);

void 
lcd_ini()
{

	    lcd_data_pin = 0x30;//send 0x30 power up LCD 
		_delay_ms(50);
		en(1);
		_delay_ms(50);
		rs(0);
		_delay_ms(50);
		rw(0);
		_delay_ms(80);
		en(0);
      // next command send 0x38
		lcd_data_pin = 0x38;   
		_delay_ms(50);
		en(1);
 		_delay_ms(50);
		rs(0);
		_delay_ms(50);
		rw(0);
		_delay_ms(80);
		en(0);
       // next command send 0x0F
		lcd_data_pin = 0x0F;       
    	_delay_ms(50);
		en(1);
		_delay_ms(50);
		rs(0);
		_delay_ms(50);
		rw(0);
		_delay_ms(80);
		en(0);
        //next command send 0x80
		lcd_data_pin = 0x80;
		_delay_ms(50);
		en(1);
		_delay_ms(50);
		rs(0);
		_delay_ms(50);
		rw(0);
		_delay_ms(80);
		en(0);
}

void lcd_data()    // function to send data on LCD
{
	lcd_data_pin=0x65;
	en(1);
	rs(1);
	rw(0);
	_delay_ms(50);
	en(0);
    
	lcd_data_pin=0x63;
	en(1);
	rs(1);
	rw(0);
	_delay_ms(50);
	en(0);
}



int main(void)
{
  
	DDRD=0XFF; //all pins of PORTD declared as output
    DDRC=0XFF;
	//DDRC = _BV(0);
	//DDRC = _BV(1);
	//DDRC = _BV(2);
	  
  
	while(1)
	{   
	    lcd_ini();
		lcd_data();
		//_delay_ms(100); //delay
		//test(0xFF);

     
		/*
		rs(0);
		_delay_ms(100); //delay

		rs(1);
		_delay_ms(100); //delay

        rw(0);
		_delay_ms(100); //delay
		rw(1);
        _delay_ms(100); //delay

		en(0);
		_delay_ms(100); //delay

		en(1);
		_delay_ms(100); //delay

		lcd_data_pin = 0xFF;
		_delay_ms(100); //delay
		lcd_data_pin = 0x00;
        */
        

	}
}
